#include <windows.h>

#include "commproto.h"
#include "protodef.h"

#include "debug.h"

#include "getdriveinfo.h"

BOOL GetDriveInfo(HWND hWnd, struct CommDev *lpDevice, BYTE bIndex, struct DriveInfo *lpInfo)
{
	BOOL fResult = FALSE;

#ifdef USE_DUMMY_DRIVE_INFO
	lpInfo->bDriveType = 4;
	lpInfo->bNumberOfTracks = 80;
	lpInfo->bSectorsPerTrack = 18;
	lpInfo->bNumberOfSides = 2;
	fResult = TRUE;
#else
	struct GetDriveInfoRequest request = { CMD_GET_DRIVE_INFO };
	request.bDriveIndex = bIndex;

	struct GetDriveInfoResponse response;

	WORD wResponseSize = sizeof(response);
	if (ProtocolTransaction(lpDevice, &request, sizeof(request), &response, &wResponseSize))
	{
		if (response.bBiosStatusCode == BIOS_CODE_SUCCESS)
		{
			lpInfo->bDriveType = response.bDriveType;
			lpInfo->bNumberOfTracks = response.bNumberOfTracks;
			lpInfo->bNumberOfSides = response.bNumberOfSides;
			lpInfo->bSectorsPerTrack = response.bSectorsPerTrack;
			fResult = TRUE;
		}
		else
		{
			TRACE("Negative BIOS status code: 0x%.2u\n", response.bBiosStatusCode);
		}
	}
#endif

	return fResult;
}
