#ifndef SETTINGS_H
#define SETTINGS_H

#include <windows.h>

#define MAX_LABEL 50

struct Settings {
	CHAR szPortName[MAX_LABEL];
	DWORD dwBaudRate;
	BYTE bDataBits;
	BYTE bParity;
	BYTE bStopBits;
	WORD wDelayBeforeWrite;
	WORD wDelayAfterWrite;
	WORD wDelayBeforeRead;
	WORD wDelayAfterRead;
	WORD wDelayBeforeReadAfterWrite;
	WORD wDelayBeforeWriteAfterRead;
	WORD wReadTimeout;
	BOOL fOutxCtsFlow;
	BOOL fOutxDsrFlow;
	BYTE bDtrControl;
	BYTE bRtsControl;
};

#define SETTINGS_CONNECT   0x01
#define SETTINGS_DELAYS    0x02
#define SETTINGS_FLOWCTRL  0x04
#define SETTINGS_ALL       0xff

void LoadSettings(struct Settings *lpSettings, BYTE bSettingsMask);
void SaveSettings(const struct Settings *lpSettings, BYTE bSettingsMask);
void LoadDefaultSettings(struct Settings *lpSettings, BYTE bSettingsMask);

struct Option {
	CHAR szLabel[MAX_LABEL];
	DWORD dwValue;
};

struct OptionList {
	const struct Option *lpOptions;
	int iCount;
};

const struct OptionList *GetPortNames(void);
const struct OptionList *GetBaudRateSettings(void);
const struct OptionList *GetDataBitsSettings(void);
const struct OptionList *GetParitySettings(void);
const struct OptionList *GetStopBitsSettings(void);
const struct OptionList *GetDtrControlSettings(void);
const struct OptionList *GetRtsControlSettings(void);

#endif
