#include <stdlib.h>
#include <windows.h>
#include <commctrl.h>

#include "maindlg.h"
#include "resource.h"
#include "guiutils.h"

#include "debug.h"

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	BOOL fFailed = FALSE;
	TRACE("Tracing enabled\n");

	if (!fFailed)
	{
		INITCOMMONCONTROLSEX icc;
		icc.dwSize = sizeof(icc);
		icc.dwICC = ICC_PROGRESS_CLASS | ICC_LISTVIEW_CLASSES;
		fFailed = !InitCommonControlsEx(&icc);
		if (fFailed)
		{
			FormatMessageBox(NULL, MB_ICONERROR, "Couldn't initialize common controls: %s", GetLastErrorText());
		}
	}

	INT_PTR iResult;
	if (!fFailed)
	{
		struct MainDlgData MainDlgData;
		InitMainDlgData(&MainDlgData);
		LPCSTR lpTemplate = MAKEINTRESOURCE(IDD_MAINDLG);
		iResult = DialogBoxParam(hInst, lpTemplate, NULL, MainDlgProc, (LPARAM) &MainDlgData);
		CleanUpMainDlgData(&MainDlgData);
	}

	return fFailed ? EXIT_FAILURE : (int) iResult;
}
