#!/usr/bin/perl

use strict;

my $name = "pc-serial-loader";
my $ret;

my @include = ( "cfg", "doc", "src", "tools", "Makefile", "LICENSE", "CHANGES" );
my @exclude = ( ".*" );

if (scalar @ARGV != 1)
{
    print "usage: makesrcdist.pl <version name>\n";
    exit 1;
}

print "Create source distribution for version $ARGV[0]\n";

my $distdir = "$name-src-$ARGV[0]";
die "Directory \"$distdir\" already exists" if (-e $distdir);
print "* CREATE   $distdir\n";
mkdir $distdir or die "Error creating directory";

foreach (@include)
{
    my $src = "$_";
    my $dst = "$distdir/$_";

    print "* COPY     $src => $dst\n";
    $ret = system("cp -a $src $dst");
    die "Error copying files" if ($ret != 0);
}

foreach (@exclude)
{
    print "* REMOVE   $_ in $distdir\n";
    $ret = system("find $distdir -iname \"$_\" | xargs rm -rf");
    die "Error removing files" if ($ret != 0);
}

my $archive = "$distdir.zip";
print "* ARCHIVE  $archive\n";
$ret = system("$ENV{'ZIP'} a -r -bso0 $archive $distdir");
die "Error creating archive" if ($ret != 0);

print "* REMOVE   $distdir\n";
$ret = system("rm -r $distdir");
die "Error removing directory" if ($ret != 0);

print "Finished successfully.\n";
